#!/usr/bin/env ruby

require 'open3'

processor = ARGV[0]
file_path = ARGV[1]
start_line = (ARGV[2] || 1).to_i
start_col = (ARGV[3] || 1).to_i
end_line = (ARGV[4] || 2**31).to_i
end_col = (ARGV[5] || 2**31).to_i

start_offset = start_col - 1
end_offset = end_col - 1

contents = File.read(file_path)

line = 1
contents.split("\n").each do |l|
  line_len = l.length + 1
  start_offset += line_len if start_line > line
  end_offset += line_len if end_line > line
  line += 1
end

data = contents[start_offset..end_offset]

Open3.popen3(processor) do |their_in, their_out, _, _|
  their_in.write(data)
  their_in.close
  contents[start_offset..end_offset] = their_out.read
end

File.open(file_path, 'w') { |file| file.write(contents) }

